VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsRegistration"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False


Public Function GenerateKey(strName As String, strCompany As String, strukey As String) As String
Dim SHA256 As New CSHA256
'This is very simple, but effective. It creates a secure modified SHA-256 hash of
'the name, company, and unique key all reversed before hashing.
    
    GenerateKey$ = SHA256.SHA256(ReverseString(strName$) & "-" & ReverseString(strCompany$) & ReverseString(UniqueProgramKey$))

End Function

Public Function ValidKey(strKey As String, strName As String, strCompany As String) As Boolean
Dim strNewKey As String, SHA256 As New CSHA256

    strNewKey$ = SHA256.SHA256(ReverseString(strName$) & "-" & ReverseString(strCompany$) & ReverseString(UniqueProgramKey$))
    
    If strNewKey$ = strKey$ Then
        ValidKey = True
    Else
        ValidKey = False
    End If

End Function

Private Function ReverseString(strString As String) As String

    Dim TempString As String, StringLength As Long
    Dim Count As Long, NextChr As String, NewString As String
    TempString$ = strString$
    StringLength& = Len(TempString$)
    Do While Count& <= StringLength&
        Count& = Count& + 1
        NextChr$ = Mid$(TempString$, Count&, 1)
        NewString$ = NextChr$ & NewString$
    Loop
    ReverseString$ = NewString$
    
End Function
