VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegistration"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-------- VBGuard Begin --------
Private Const MODULENAME_ = "clsRegistration"
'-------- VBGuard End ----------

Public Function GenerateKey(strName As String, strCompany As String) As String
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GenerateKey"
'-------- VBGuard End ----------
Dim SHA256 As New CSHA256
'This is very simple, but effective. It creates a secure modified SHA-256 hash of
'the name, company, and unique key all reversed before hashing.
    
104     GenerateKey$ = SHA256.SHA256(ReverseString(strName$) & "-" & ReverseString(strCompany$) & ReverseString(UniqueProgramKey$))

'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Function ValidKey(strKey As String, strName As String, strCompany As String) As Boolean
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "ValidKey"
'-------- VBGuard End ----------
Dim strNewKey As String, SHA256 As New CSHA256

102     strNewKey$ = SHA256.SHA256(ReverseString(strName$) & "-" & ReverseString(strCompany$) & ReverseString(UniqueProgramKey$))
    
104     If strNewKey$ = strKey$ Then
105         ValidKey = True
106     Else
107         ValidKey = False
108     End If

'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Private Function ReverseString(strString As String) As String
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "ReverseString"
'-------- VBGuard End ----------

101     Dim tempstring As String, StringLength As Long
102     Dim count As Long, NextChr As String, NewString As String
103     tempstring$ = strString$
104     StringLength& = Len(tempstring$)
105     Do While count& <= StringLength&
106         count& = count& + 1
107         NextChr$ = Mid$(tempstring$, count&, 1)
108         NewString$ = NextChr$ & NewString$
109     Loop
110     ReverseString$ = NewString$
    
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function
